local c={}

local function getDist(p1,p2)
	local dist=math.abs(p1-p2)
	local dist2=#road.blocks-dist
	if dist>dist2 then dist=dist2 end
	return dist
end

local function begin(a,b,coll)
	local objA=a:getUserData()
	local objB=b:getUserData()
	if objB.posInRoad==nil or objA.posInRoad==nil then print(objA.model,objB.type) end
	local dist=getDist(objB.posInRoad,objA.posInRoad)
	if objA.type=="sensor" and objB.type=="car" then
		if dist<5 then
			objB.posInRoad=objA.posInRoad
		end
	end
end

local function pre(a,b,coll)

	local objA=a:getUserData()
	local objB=b:getUserData()
	local dist=getDist(objA.posInRoad,objB.posInRoad)
	if dist>10 then
		coll:setEnabled(false)
	end
end

local function post(a, b, coll, normalimpulse1, tangentimpulse1, normalimpulse2, tangentimpulse2)
	local objA=a:getUserData()
	local objB=b:getUserData()
	if objA.type=="car" and objB.type~="sensor" then
		if math.abs(tangentimpulse1)>0.5 or math.abs(normalimpulse1)>0.5 then
			require("objs/spark"):new(objA,coll,normalimpulse1, tangentimpulse1)
		end
	end
end



function c.beginContact(a,b,coll)
	begin(a,b,coll)
	begin(b,a,coll)
end

function c.endContact(a,b,coll)
end

function c.pre(a,b,coll)
	pre(a,b,coll)
end


function c.post(a, b, coll, normalimpulse1, tangentimpulse1, normalimpulse2, tangentimpulse2)
	post(a, b, coll, normalimpulse1, tangentimpulse1, normalimpulse2, tangentimpulse2)
	post(b, a, coll, normalimpulse1, tangentimpulse1, normalimpulse2, tangentimpulse2)
end

return c

