require "libs/util"
class=require "libs/middleclass"
camera=require("libs/gamera").new(0,0,65535,65535)
camera_mini=require("libs/gamera").new(0,0,65535,65535)
shake_cam= require("libs/shakycam").new(camera)
vec=require "libs/vector"
tween=require "libs/tween"
render=require("render")
explosion= require "objs/explode"
game={}
love.math.setRandomSeed(os.time())


function love.load() 
    game.font = love.graphics.newFont("lcd.ttf", 16)
    love.graphics.setFont(game.font)
    game.carIndex=0
    game.world = love.physics.newWorld(0,0)
    game.trace={}
    game.puff={}
    contact=require("contact")
    game.world:setCallbacks(contact.beginContact, contact.endContact,contact.pre,contact.post)
    love.physics.setMeter(64)
    road=require("objs/road"):new()
    
    game.car=require("objs/car"):new()
    game.car:setPosition(road.blocks[1].body:getPosition())
    --game.car.isAICtrl=false
    game.oRPM=0
    game.npc={}
    game.ex={}
    game.spark={}
    for i=1,5 do
        game.npc[i]=require("objs/car"):new()
        game.npc[i]:setPosition(road.blocks[i+1].body:getPosition())
        game.npc[i].posInRoad=i+1
    end
    


    game.car.ai=require("ai")


    item=require("objs/item"):new(3,0.2,"null")
    game.cam=require "camera"
    game.cam:new()
end




function love.draw()
    game.cam:draw()
    render()
end

function love.update(dt) 
    
    
    game.car:update(dt)
    for k,v in pairs(game.npc) do
        v:update(dt)
    end
    game.world:update(dt)

    game.cam:update()
    
    for k,v in pairs(game.ex) do
        v:update(dt)
    end
    for k,v in pairs(game.puff) do
        v:update()
        if v.destroy==true then
            table.remove(game.puff, k)
        end
    end

    love.window.setTitle(tostring(love.timer.getFPS()))
end 

function love.keypressed(key,isrepeat) --Callback function triggered when a key is pressed.

    game.car:key(key)

    if key=="escape" then
        local title = "QUIT"
        local message = "Are U sure to quit?"
        local buttons = {"OK", "No!", escapebutton = 2}
        local pressedbutton = love.window.showMessageBox(title, message, buttons)
        if pressedbutton == 1 then
            love.event.quit()
        elseif pressedbutton == 2 then
            -- etc.
        end
    end

    if key=="1" and game.car.visible==true then
        table.insert(game.ex,explosion:new(game.car,4,500,1))
        for i=1,4 do
            table.insert(game.ex,explosion:new(game.car.tires[i],5,500,1))
        end
        game.cam:shake()
    end
end

function love.mousepressed(x,y,button) --Callback function triggered when a mouse button is pressed.

end 

--[[
function love.quit() --Callback function triggered when the game is closed.
end 
function love.resize(w,h) --Called when the window is resized.
end 
function love.textinput(text) --Called when text has been entered by the user.
end 
function love.threaderror(thread, err ) --Callback function triggered when a Thread encounters an error.
end 
function love.visible() --Callback function triggered when window is shown or hidden.
end 
function love.mousefocus(f)--Callback function triggered when window receives or loses mouse focus.
end
function love.mousepressed(x,y,button) --Callback function triggered when a mouse button is pressed.
end 
function love.mousereleased(x,y,button)--Callback function triggered when a mouse button is released.
end 
function love.errhand(err) --The error handler, used to display error messages.
end 
function love.focus(f) --Callback function triggered when window receives or loses focus.
end 
function love.keypressed(key,isrepeat) --Callback function triggered when a key is pressed.
end
function love.keyreleased(key) --Callback function triggered when a key is released.
end 
function love.run() --The main function, containing the main loop. A sensible default is used when left out.
end
]]