local car=class("car")

function car:initialize()


	self.maxFSpeed=1000
	self.maxBSpeed=-300
	self.maxDriveForce=100
	self.maxLImp=3
	self.killSpeed=1/10
	self.turnPower=30
	self.power=100
	self.powerRate=self.power/80
	self.isAutoTrans=true
	self.color={love.math.random(1,255),love.math.random(1,255),love.math.random(1,255)}

	game.carIndex=game.carIndex+1
	self.index=game.carIndex
	self.type="car"
	self.body = love.physics.newBody(game.world, 0, 0, "dynamic")
	self.body:setAngularDamping(3)

	self.visible=true	
	self.posInRoad=1
	self.oPos=1
	self.lap=1
	self.isAICtrl=true
	self.stop=0
	self.shift=1
	self.isPowerUp=false
	self.powerUpPower=20
	self.n2o=100
	self.cmd={}
	local tab={1.5,0,
			3,2.5,
			2.8,5.5,
			1,10,
			-1,10,
			-2.8,5.5,
			-3,2.5,
			-1.5,0}
	for k,v in pairs(tab) do
		tab[k]=v*4
	end
	self.shape = love.physics.newPolygonShape(tab)
	self.fixture = love.physics.newFixture(self.body, self.shape, 1)
	self.fixture:setUserData(self)
	self.fixture:setGroupIndex( -1-self.index )

	self.shell={}
	self.shell.shape = love.physics.newPolygonShape(-16,-3,16,-3,16,40,-16,40)
	self.shell.fixture = love.physics.newFixture(self.body, self.shell.shape,1)
	self.shell.fixture:setUserData(self)
	self.shell.fixture:setGroupIndex( -1-self.index )
	self.shell.shape2 = love.physics.newCircleShape(-15,-2,2)
	self.shell.fixture2 = love.physics.newFixture(self.body, self.shell.shape2,0.01)
	self.shell.fixture2:setUserData(self)
	self.shell.fixture2:setGroupIndex( -1-self.index )	
	self.shell.shape3 = love.physics.newCircleShape(15,2,2)
	self.shell.fixture3 = love.physics.newFixture(self.body, self.shell.shape3,0.01)
	self.shell.fixture3:setUserData(self)
	self.shell.fixture3:setGroupIndex( -1-self.index )	
	self.shell.shape4 = love.physics.newCircleShape(15,39,2)
	self.shell.fixture4 = love.physics.newFixture(self.body, self.shell.shape4,0.01)
	self.shell.fixture4:setUserData(self)
	self.shell.fixture4:setGroupIndex( -1-self.index )	
	self.shell.shape5 = love.physics.newCircleShape(-15,39,2)
	self.shell.fixture5 = love.physics.newFixture(self.body, self.shell.shape5,0.01)
	self.shell.fixture5:setUserData(self)
	self.shell.fixture5:setGroupIndex( -1-self.index )	

-- tiresPos -12,3;12,3,-12,34,12,34

	self.tires={}
	local jointDef={}
	jointDef.bodyA=self.body
	jointDef.enableLimit=true
    local makeTire=require("objs/tires")
    local tire=makeTire:new(-3*4,0.75*4,self)
    jointDef.bodyB=tire.body
    local joint = love.physics.newWeldJoint(jointDef.bodyA, jointDef.bodyB, 0, 0, false)
    self.tires[1]=tire



    local makeTire=require("objs/tires")
    local tire=makeTire:new(3*4,0.75*4,self)
    jointDef.bodyB=tire.body
    local joint = love.physics.newWeldJoint(jointDef.bodyA, jointDef.bodyB, 0, 0, false) 
    self.tires[2]=tire



    local makeTire=require("objs/tires")
    local tire=makeTire:new(-3*4,8.5*4,self)
    jointDef.bodyB=tire.body
    local joint=love.physics.newRevoluteJoint(jointDef.bodyA, jointDef.bodyB, -3*4,8.5*4, false) 
    self.tires[3]=tire
    self.flJoint=joint
    tire.parent=self
    tire.isFront=true


    local makeTire=require("objs/tires")
    local tire=makeTire:new(3*4,8.5*4,self)
    jointDef.bodyB=tire.body
    local joint=love.physics.newRevoluteJoint(jointDef.bodyA, jointDef.bodyB, 3*4,8.5*4, false) 
    self.tires[4]=tire
    self.frJoint=joint
    tire.parent=self
    tire.isFront=true


end


function car:setPosition(px,py)
	self.body:setPosition(px,py)
    for k,v in pairs(self.tires) do
        v.body:setPosition(px,py) 
    end
end

function car:setActive(toggle)
	self.body:setActive(toggle)
	for k,v in pairs(self.tires) do
		v.body:setActive(toggle)
	end
end

function car:getForwardSpeed()
	local axis=vec()
	axis.x , axis.y=self.tires[3].body:getWorldVector(0, 1)
	local v=vec()
	v.x,v.y=self.tires[3].body:getLinearVelocity()
	return v*axis
end


local function clamp(a,low,high)
	if a>math.pi then a=a-2*math.pi end
	return math.max(low,math.min(a,high))
end


function car:addPuff()
	if self.visible==false then return end
	local x= (self.tires[1].body:getX() + self.tires[2].body:getX())/2
	local y= (self.tires[1].body:getY() + self.tires[2].body:getY())/2
	local num
	local time
	if self.isPowerUp then
		num=10
		time=1.5
	else
		num=1
		time=0.5
	end

	for i=1,num do
		if love.math.random()>0.7 then
			local puff=require("objs/puff"):new(x,y,time,self.alpha,self.isPowerUp)
		end
	end
end





function car:lapCheck()
    if self.posInRoad==math.ceil(#road.blocks/2) then self.lapToggle=true end
    if self.oPos==#road.blocks and self.posInRoad==1 and self.lapToggle==true then
        self.lap=self.lap+1
        self.lapToggle=false
    end
end

function car:updateShift()
	
	if self.isAutoTrans then
		local rpm=math.floor(6000*math.getDistance(0,0,game.car.body:getLinearVelocity())/self.maxFSpeed)
		if rpm>4500 then
			self.shift=self.shift+1
			if self.shift>6 then self.shift=6 end
		elseif rpm<3000 then
			self.shift=self.shift-1
			if self.shift<1 then self.shift=1 end		
		end
	else
		if love.keyboard.isDown("up")  and self.keyToggle==false then
			self.shift=self.shift+1
			self.keyToggle=true
			if self.shift>6 then self.shift=6 end
		end

		if love.keyboard.isDown("down") and self.keyToggle==false then
			self.shift=self.shift-1
			self.keyToggle=true
			if self.shift<1 then self.shift=1 end
		end

		if (not love.keyboard.isDown("up")) and (not love.keyboard.isDown("down")) then
			self.keyToggle=false
		end

		if self.isAICtrl then
			for k,v in pairs(self.cmd) do
				if v=="reset" then
					self:reset()
					return
				end

				if v=="shiftUp" then
				 	self.shift=self.shift+1
					if self.shift>6 then self.shift=6 end
				end
				if v=="shiftDown" then 
					self.shift=self.shift-1
					if self.shift<1 then self.shift=1 end
				end

				if v=="powerUp" and self.n2o>0 then
					self.isPowerUp=true
					self.n2o=self.n2o-1
					if self.n2o<0 then self.n2o=0 end
				else
					self.isPowerUp=false
				end
			end
		end

	end
	self.maxFSpeed=200*self.shift*self.powerRate
	self.maxDriveForce=self.power/self.shift/self.powerRate
end

function car:reset()
	self:setPosition(road.blocks[self.posInRoad].body:getPosition())
	self.body:setAngle(road.blocks[self.posInRoad].body:getAngle())
	self.body:setLinearVelocity(0,0)
	self.body:setAngularVelocity(0)
	for k,v in pairs(self.tires) do
		v:reset()
	end
end

function car:key(key)
	if key=="t" and self==game.car then
        if self.isAICtrl then
            self.isAICtrl=false
        else
            self.isAICtrl=true
        end
    end

	if self.isAICtrl==true then return end
	if key=="r" then
		self:reset()
	end

	if key=="f" then
		if self.isAutoTrans==true then
			self.isAutoTrans=false
		else
			self.isAutoTrans=true
		end
	end
end


function car:update(dt)
	self:ai()
	self:lapCheck()
	self:updateShift()
	for i,v in ipairs(self.tires) do
		v:update(dt,self.isAICtrl)
	end
	
	self:addPuff(dt)

	local cRot=self.body:getAngle()
	local rRot=road.blocks[self.posInRoad].body:getAngle()
	local dist=math.abs(cRot-rRot)
	local dist2=math.pi*2-dist
	if dist>dist2 then dist=dist2 end

	if self.oPos>self.posInRoad and self.oPos~=#road.blocks and dist>math.pi/2 then
		self.wrongWay=true
	elseif self.oPos<self.posInRoad then
		self.wrongWay=false
	end
	self.oPos=self.posInRoad
	if love.keyboard.isDown("p") and self.n2o>0 and not self.isAICtrl then
		self.isPowerUp=true
		self.n2o=self.n2o-1
		if self.n2o<0 then self.n2o=0 end
	else
		self.isPowerUp=false
	end 
end


local function getDist(p1,p2)
	local dist=math.abs(p1-p2)
	local dist2=#road.blocks-math.abs(p1-p2)
	if dist>dist2 then dist=dist2 end
	return dist
end


function car:draw()	
	if not self.visible then return end
	self.alpha=math.getAlpha(math.getLoopDist(game.car.posInRoad,self.posInRoad,road.count))
	for i,v in ipairs(self.tires) do
		v:draw(self.alpha)
	end
	love.graphics.setColor(self.color[1], self.color[2], self.color[3], self.alpha)
	love.graphics.polygon("outline",self.body:getWorldPoints(self.shape:getPoints()))
	--love.graphics.setColor(0, 255, 255, alpha)
	--love.graphics.polygon("line",self.body:getWorldPoints(self.shell.shape:getPoints()))
	--love.graphics.line(self.body:getX(),self.body:getY(),road.blocks[self.testPos].body:getPosition())
end


function car:ai()
	if not self.isAICtrl then return end
	self.cmd={}
	local carSpeed=	self.tires[3]:getForwardVelocity():len()
	local testPos=self.posInRoad+math.ceil(carSpeed/200)+2
	self.testPos=testPos
	if testPos>#road.blocks then testPos=testPos-#road.blocks end
	if testPos<=0 then testPos=testPos+#road.blocks end
	local testX,testY=road.blocks[testPos].body:getPosition()
	local localX,localY=self.body:getLocalPoint(testX,testY)
	local localAngle=math.getRot(localX,localY,0,0)
	if localAngle>math.pi then localAngle=localAngle-2*math.pi end
	if localAngle<-math.pi/8 then table.insert(self.cmd,"left") end
	if localAngle>math.pi/8 then table.insert(self.cmd,"right") end
	if math.abs(localAngle)<math.pi/6 then table.insert(self.cmd,"forward")  end
	if math.abs(localAngle)>math.pi/3 then table.insert(self.cmd,"brake") end
	if self.oPos==self.posInRoad then self.stop=self.stop+1 else self.stop=1 end
	if self.stop>=100 then table.insert(self.cmd,"back") end --table.insert(self.cmd,"reset") end
	if carSpeed<=100 then table.insert(self.cmd,"forward") end
end
return car